angular.module("umbraco.services").factory("taskManService",
	function ($timeout, $rootScope, deployService) {

	var service = {
		events: $({}),

		currentTask : undefined,
		latestTask : undefined,
		active: false,
		subscribers: 0,


		getTaskState : function(task){
			if(!task || task === "null"){
				return "null";
			}
		},

		subscribe : function(){
			service.subscribers++;

			//turn on the monitoring on first subscription
			if(service.active === false){
				service.monitorTaskmanager();
			}
		},

		unsubscribe : function(){
			service.subscribers--;

			//this will turn of all polling
			if(service.subscribers <= 0){
				service.active = false;
				service.subscribers = 0;
			}
		},

		monitorTaskmanager : function(){

			var check = function(){
				timer = $timeout(function(){

					//only perform the http request if the user is logged in
					deployService.taskStatus().success(function(response){

						//if response id is not equal to current task or current state

						if(response !== "null" && !_.isEqual(response, service.latestTask) ){
							service.events.trigger("task-update", response);

							if(!service.currentTask || service.currentTask.id !== response.id){
								service.events.trigger("task-new", response);
							}

							service.currentTask = response;

							//the task is out of the current tasks queue
							if(response.complete){
								service.latestTask = response;
								service.currentTask = undefined;

								//it is our current task list because its either done or has an error
								if (response.error) {
									service.events.trigger("task-error", response);
								}else{
									service.events.trigger("task-complete", response);
								}
							}
						}

						//keep checking if active
						if(service.active === true){
							check();
						}


						}).error(function(err){
							service.events.trigger("error", err);
							service.currentTask = undefined;


							//keep checking if active
							if(service.active === true){
								check();
							}
						});

				}, 2000);
			};

			//only start the loop if it is not already active
			if(service.active === false){
				//activate the service to start the monitor loop
				service.active = true;
				check(2000);
			}
		}
	};

	return service;

}).run(function(taskManService, eventsService, userService){

	//happens on logout / timeout
	eventsService.on("app.notAuthenticated", function() {
        taskManService.subscribers = 0;
    });
});
